attribute vec3 tangent;
attribute vec3 binormal;

uniform vec4 lightPos;

varying	vec3 g_lightVec;
varying	vec3 g_viewVec;


void main() 
{
	
	gl_Position = ftransform(); 
	gl_FogFragCoord = gl_Position.z;


	mat3 tBNMatrix = mat3(tangent,binormal,-gl_Normal);
	
	vec3 n = gl_Normal; //=normalize(gl_NormalMatrix * gl_Normal);
	vec3 t = tangent;   //=normalize(gl_NormalMatrix * vTangent);
	vec3 b = binormal;  //=cross(n,t);

	// current vertex
	vec4 mv_Vertex = gl_ModelViewProjectionMatrix * gl_Vertex;
	// view vector
	g_viewVec = tBNMatrix * vec3(mv_Vertex);

	// calculating the light vector and move into tangent space
	vec4 light = lightPos;
	vec3 lightVec = 0.2 * (normalize(light.xyz) - mv_Vertex.xyz);
	g_lightVec = tBNMatrix * lightVec; 

	// im OpenGL Programm angegebene Texturkoordinaten weiterleiten
	gl_TexCoord[0] = gl_MultiTexCoord0;

 }
 
