package gui;

import javax.swing.*;

public class CGSettingFrm extends JFrame {

	private static final long serialVersionUID = 000000l;
	
	// GUI Elements
	private JPanel contentPane;
	private JTextArea infoArea;
	private JTextField factorField;
	private float factor;
	
	public CGSettingFrm(){
		super( "Settings" );
		initialize();
	}
	
	private void initialize(){
		factor = 1000.0f;
		
		this.setContentPane(getMyContentPane());
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE );
		this.setBounds( 10, 10, 310, 160 );
	}
	
	private JPanel getMyContentPane() {
		if (contentPane == null) {
			contentPane = new JPanel();
			contentPane.setOpaque(true);
			contentPane.add(new JLabel("Multiplication Factor"));
			contentPane.add(getInfoArea());
			contentPane.add(getFactorField());
		}
		return contentPane;
	}
	
	private JTextArea getInfoArea() {
		if (infoArea == null) {
			infoArea = new JTextArea();
			String s = "Set the multiplication factor for the [0;1] normalized sizes and position values. This factor is used when creating the XML output file. The default value is 1000.";
			infoArea.setText(s);
			infoArea.setLineWrap(true);
			infoArea.setWrapStyleWord(true);
			infoArea.setEditable(false);
			infoArea.setFocusable(false);
			infoArea.setSize(290,5);
			infoArea.setBackground(this.getBackground());
		}
		return infoArea;
	}
	
	private JTextField getFactorField() {
		if (factorField == null) {
			factorField = new JTextField();
			factorField.setText((new Float(factor)).toString());
			factorField.setColumns(8);
			factorField.setEditable(true);
		}
		return factorField;
	}
	
	public float getFactor(){
		float fac = (new Float(factorField.getText())).floatValue();
		return fac;
	}
	
	public void setFactor(float f){
		factor = f;
		factorField.setText((new Float(f)).toString());
	}
}
