package objects;

import java.util.*;
import java.awt.Color;

/* Class that represents the table structure for objects that
 * can be added to the scene
 */

public class CGObjects {

	private static Vector data;
	private Vector columnNames;
	private int selectedRow;
	
	// Constructor
	public CGObjects(){
		if (data==null) data = new Vector();
		selectedRow = -1;

		// Set the Table headers
		if (columnNames==null) columnNames = new Vector();
		columnNames.add("Name");
		columnNames.add("WidthX");
		columnNames.add("WidthZ");
	}
	
	// Method to add a data row
	public void addDataRow(CGObject ob){
		Vector temp = new Vector();
		temp.add(ob.getName());
		temp.add(new Float(ob.getWidthX()));
		temp.add(new Float(ob.getWidthZ()));
		temp.add(ob);
		data.add(temp);
		// System.out.println("Object added: " + ob.getName());
	}
	
	// Method to set the currently selected index (= a specific object)
	public void setSelectedIndex(int i){
		selectedRow = i;
	}
	
	// Method that returns the column names
	public Vector getColumnNames(){
		return columnNames;
	}
	
	// Method that returns the objects vector itself
	public Vector getData(){
		return data;
	}
	
	// Method that returns an integer which is the index of the selected row
	public int getSelectedRow(){
		return selectedRow;
	}
	
	public static CGObject createObject(float f1, float f2, String n, Color c, String[] a){
		CGObject o = new CGObject(f1,f2,n,c,a);
		return o;
	}
}
