package util;

import java.awt.Color;
import java.io.*;
import java.util.Enumeration;
import java.util.Vector;

import objects.CGAddedObject;

import gui.*;

public class CGSaveWriter {
	private RandomAccessFile raf;
	
	public CGSaveWriter (RandomAccessFile r){
		raf = r;
	}
	
	public void save(){
		try{
			Vector ob = CGMainFrm.getAddedObjects();
			String[] pa = CGMainFrm.getPaths();
			
			// Write Header
			raf.writeBytes("% This is an automatically saved file of the CGLevelEditor.\n");
			raf.writeBytes("% Don't change it to avoid parsing errors when loading the level.\n\n");
			
			raf.writeBytes("map,"+pa[0]+";\n");
			raf.writeBytes("buf,"+pa[1]+";\n");
			raf.writeBytes("obj,"+pa[2]+";\n");
			raf.writeBytes("factor,"+CGMainFrm.getFactor()+";\n\n");
			
			// Loop through added objects
			for (Enumeration en = ob.elements(); en.hasMoreElements(); ){
				CGAddedObject ao = ((CGAddedObject)(en.nextElement()));
	
			  /*private float widthX, widthZ;
				private float posX, posZ;
				private String name;		// Name of this object
				private float angleY;		// The anglethis object is rotated (0 <= angleY <= 360)
				private Color col;			// The color this object will be painted in
				private Color colBU;		// A backup of the color
				private String[] attributes;*/
				
				// Attributes
				raf.writeBytes(ao.getWidthX() + "," + ao.getWidthZ() + "," + ao.getPosition().x + "," + ao.getPosition().y + "," +
							   ao.getName() + "," + ao.getAngle() + "," + 
							   ao.getColor().getRed() + "-" + ao.getColor().getGreen() + "-" + ao.getColor().getBlue() + "," + 
							   ao.getBUColor().getRed() + "-" + ao.getBUColor().getGreen() + "-" + ao.getBUColor().getBlue());
				// Attribute Array
				for (int i=0;i<ao.getAttributes().length;i++){
					raf.writeBytes("," + ao.getAttributes()[i]);
				}
				raf.writeBytes(";\n");
			}
			
		}
		catch(IOException ex){
			System.out.println("Error: " + ex.getMessage());
		}
	}
}
